use wasmer::{imports, Instance, Module, Store, Value};

static WASM: &[u8] =
    include_bytes!("../../../target/wasm32-unknown-unknown/debug/example_plugin.wasm");

fn main() {
    let mut store = Store::default();
    let module = Module::new(&store, WASM).expect("failed to load Wasm module");

    let import_object = imports! {};
    let instance = Instance::new(&mut store, &module, &import_object)
        .expect("failed to instantiate Wasm module");
    let add = instance
        .exports
        .get_function("add")
        .expect("failed to bind function add");
    let three = add
        .call(&mut store, &[Value::I32(1), Value::I32(2)])
        .expect("failed to execute add");
    let three = three.first().unwrap().unwrap_i32();
    println!("three: {}", three); // "three: 3"
}
